//+------------------------------------------------------------------+
//|                                               DAILY_TREND_EA.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

#property copyright "Copyright ? 2008, ForexArea.com"
#property link      "http://www.forexarea.com"

extern double  dLots      = 0.01;
int     iMagicNumber      = 1279047;
double Poin;
extern double iStopLoss   = 330 ; 
extern double iTakeProfit1 = 2000 ;
extern bool   useTrailing = true;
extern double iTrailingStop = 400;
extern bool   Show_Settings  = true;

extern int PAX =9;
extern int Ma_PAX=5;

double highest_high, lowest_low, high_price, low_price;
double last_high, last_low ;
int   iTicket, iTotalOrders,trend,Status,direction,signal;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
iMagicNumber    = subGenerateMagicNumber( iMagicNumber, Symbol(), Period() );

if ( Show_Settings )
       PrintDetails();

  watermark(); 
//----
//Checking for unconventional Point digits number
if (Point == 0.00001) Poin = 0.0001; //6 digits
else if (Point == 0.001) Poin = 0.01; //3 digits (for Yen based pairs)
else Poin = Point; //Normal 
   

   return(0);
  }
   
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {

//----
   int  iCrossed, xCrossed;
   
   // get total number of orders 
   iTotalOrders = OrdersTotal();
   
   // see if we have a new cross
   iCrossed  = CheckForCross();
   
   // do functions 
 //  if(iCrossed !=0 && iTotalOrders==0) PlaceOrders(iCrossed);
 //  if(iTotalOrders ==0 ) PlaceOrder(iCrossed);
  if(iTotalOrders != 0 && useTrailing == true) TrailingStop(iTotalOrders);
//----
   return(0);
  }
//+------------------------------------------------------------------+
/*
void PlaceOrders(int iSignal){

  
     
   
   if(iSignal == 1 )
   {
 //     if (OrderType()==1) {OrderClose(OrderTicket(),dLots,Ask,3,Red); 
 //      Sleep(5000);}
      iTicket=OrderSend(Symbol(),OP_BUY,dLots,Ask,3,Bid-iStopLoss*Poin,Ask+iTakeProfit1*Poin,"5 MINUTE PROFIT",iMagicNumber,0,Green);
      if(iTicket>0){
         if(OrderSelect(iTicket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
      }else{
         Print("Error opening BUY order : ",GetLastError());
      }
   }
   
   if(iSignal == 2 )
   {
 //     if (OrderType()==0) {OrderClose(OrderTicket(),dLots,Bid,3,White);
 //      Sleep(5000); } 
      iTicket=OrderSend(Symbol(),OP_SELL,dLots,Bid,3,Ask+iStopLoss*Poin,Bid-iTakeProfit1*Poin,"5 MINUTE PROFIT",iMagicNumber,0,Red);
      if(iTicket>0){
         if(OrderSelect(iTicket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
      }else{
         Print("Error opening SELL order : ",GetLastError());
      }
   }
   
   return(0);
   }
*/

//+---------------------------------------------------------------------+

void TrailingStop(int iTotal){

   int iCount;
   
   if(iTrailingStop < 1)return(-1); // error
   
   for(iCount=0;iCount<iTotal;iCount++){

      OrderSelect(iCount, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber() == iMagicNumber)
         switch(OrderType()){
            case OP_BUY:
               if(Bid-OrderOpenPrice()>Poin*iTrailingStop){
                  if(OrderStopLoss()<Bid-Poin*iTrailingStop){
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Poin*iTrailingStop,OrderTakeProfit(),0,Green);
                  }
               }
               break;
            case OP_SELL:
               if((OrderOpenPrice()-Ask)>(Poin*iTrailingStop)){
                  if((OrderStopLoss()>(Ask+Poin*iTrailingStop)) || (OrderStopLoss()==0)){
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Poin*iTrailingStop,OrderTakeProfit(),0,Red);
                  }
               }
               break;
         }
      }
   
      return(0);
}

   
 //+---------------------------------------------------------+
 // check if moving averages have crossed
      
   int CheckForCross(){

  
   static int siLastDirection = 0;
   static int siCurrentDirection = 0;
   int i, cnt  ;
   int buyorder=0;
   int sellorder=0;
   int dir=0;

  int total = OrdersTotal();
  
         double PAX_now   =    iCustom(Symbol(),NULL, "PAX2",PAX,Ma_PAX,0,0);
         double PAX_prev  =    iCustom(Symbol(),NULL, "PAX2",PAX,Ma_PAX,0,+1);
         double SPAX_now  =   iCustom(Symbol(),NULL, "PAX2",PAX,Ma_PAX,5,0);
         double SPAX_prev =   iCustom(Symbol(),NULL, "PAX2",PAX,Ma_PAX,5,+1);
         
         if(PAX_now > SPAX_now && PAX_prev < SPAX_prev) dir=1;//up
         else if(PAX_now < SPAX_now && PAX_prev > SPAX_prev) dir=2;//down
         
        
      i= 0;
      for (i = 0; i < total; i++) 
      {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == iMagicNumber) 
         {
         if (OrderType()==OP_BUY) {buyorder = buyorder +1;}
         else if (OrderType()==OP_SELL) {sellorder = sellorder +1;}
         } 
      }
      
      int day_day = 0;
      int day_time = 0;
      bool trade = false;
      if(DayOfWeek()==1 || DayOfWeek()==2 || DayOfWeek()==3 || DayOfWeek()==4 || DayOfWeek()==5) day_day=1;
      if(Hour() >= 6 && Hour() <= 18) day_time = 1;//trade between 6 am and 6 pm.
      if(day_day == 1 && day_time == 1) trade = true;
      
      double Ticket=0;
      if (buyorder==0 && sellorder==0 ){
      RefreshRates();
      if (dir==1 ){ 
      iTicket=OrderSend(Symbol(),OP_BUY,dLots,Ask,3,Bid-iStopLoss*Poin,Ask+iTakeProfit1*Poin,"DAILY PROFIT",iMagicNumber,0,Green);  
      if(Ticket<0){Print("Buy OrderSend 1 failed with error #",GetLastError());}
      }
       
      else if (dir==2){   
      iTicket=OrderSend(Symbol(),OP_SELL,dLots,Bid,3,Ask+iStopLoss*Poin,Bid-iTakeProfit1*Poin,"DAILY PROFIT",iMagicNumber,0,Red); 
      if(Ticket<0){Print("Sell OrderSend 1 failed with error #",GetLastError());}
    }
     } 
    
 /*     
    
      if (dir==1 ) siCurrentDirection = 1;//buy
      else if (dir==2) siCurrentDirection = 2;//sell
 //     else siCurrentDirection = 0; //no trade
      // check for buy or sell signal
      
      if(siCurrentDirection != siLastDirection){
         // they have so return the new signal
         siLastDirection = siCurrentDirection;
         return (siLastDirection);
        
      }  
 */
   return(0);
} 

//+-----------------------------------------------------------------------+

void watermark()
  {
   ObjectCreate("AI", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("AI","DAILY PROFIT EA",12, "Verdana", RoyalBlue);
   ObjectSet("AI", OBJPROP_CORNER, 2);
   ObjectSet("AI", OBJPROP_XDISTANCE, 5);
   ObjectSet("AI", OBJPROP_YDISTANCE, 10);
   return(0);
  }
  //----------------------- GENERATE MAGIC NUMBER BASE ON SYMBOL AND TIME FRAME FUNCTION
//----------------------- SOURCE   : PENGIE
//----------------------- MODIFIED : FIREDAVE
int subGenerateMagicNumber(int iMagicNumber, string symbol, int timeFrame)
{
   int isymbol = 0;
   if (symbol == "EURUSD")       isymbol = 1;
   else if (symbol == "GBPUSD")  isymbol = 2;
   else if (symbol == "USDJPY")  isymbol = 3;
   else if (symbol == "USDCHF")  isymbol = 4;
   else if (symbol == "AUDUSD")  isymbol = 5;
   else if (symbol == "USDCAD")  isymbol = 6;
   else if (symbol == "EURGBP")  isymbol = 7;
   else if (symbol == "EURJPY")  isymbol = 8;
   else if (symbol == "EURCHF")  isymbol = 9;
   else if (symbol == "EURAUD")  isymbol = 10;
   else if (symbol == "EURCAD")  isymbol = 11;
   else if (symbol == "GBPUSD")  isymbol = 12;
   else if (symbol == "GBPJPY")  isymbol = 13;
   else if (symbol == "GBPCHF")  isymbol = 14;
   else if (symbol == "GBPAUD")  isymbol = 15;
   else if (symbol == "GBPCAD")  isymbol = 16;
   else                          isymbol = 17;
   if(isymbol<10) iMagicNumber = iMagicNumber * 10;
   return (StrToInteger(StringConcatenate(iMagicNumber, isymbol, timeFrame)));
}
void PrintDetails()
{
   string sComment   = "";
   string sp         = "----------------------------------------\n";
   string NL         = "\n";
   
   sComment = sp;
   sComment = sComment + "DAILY PROFIT EA"+ NL;
   sComment = sComment + "TakeProfit 1=" + DoubleToStr(iTakeProfit1,0) + " | ";
//   sComment = sComment + "TakeProfit 2=" + DoubleToStr(iTakeProfit2,0) + " | ";   
   sComment = sComment + "StopLoss=" + DoubleToStr(iStopLoss,0) + NL;
   sComment = sComment + "TrailingStop=" + DoubleToStr(iTrailingStop,0) + " | ";
   sComment = sComment + "OrderLots=" +DoubleToStr(OrderLots(),2) +NL;
//   sComment = sComment + "Plus Accum=" +DoubleToStr(plus_accum,5) +NL;
//   sComment = sComment + "Minus Accum=" +DoubleToStr(minus_accum,5) +NL;
//   sComment = sComment + "Sum Accum=" +DoubleToStr(sum_accum,5) +NL;
//   sComment = sComment + "Percent=" +DoubleToStr(sum_percent,4) +NL;
//   sComment = sComment + "Activity=" +DoubleToStr(activity,2) +NL;
 //  sComment = sComment + "Lowest Low=" +DoubleToStr(lowest_low,1) +NL;
 //  sComment = sComment + "MA Status=" +DoubleToStr(Status,1) +NL;
 //  sComment = sComment + "Hull Direction=" +DoubleToStr(direction,1) +NL;
 //  sComment = sComment + "MACD signal=" +DoubleToStr(signal,1) +NL;
 //  sComment = sComment + "If MM used, risk=" +DoubleToStr(RiskPercent,1) + "%" + NL;
   sComment = sComment + "Symbols: "+Symbol()+ NL;
   sComment = sComment + sp;
   //---- 10 seconds wait
   Sleep(10000);
   //---- refresh data
   RefreshRates();

   Comment(sComment);
}

